#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_minimum 1.0
#property indicator_maximum 4.0
#property indicator_buffers 8
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Lime
#property indicator_color4 Red
#property indicator_color5 Lime
#property indicator_color6 Red
#property indicator_color7 Lime
#property indicator_color8 Red

extern string EMA = "The input parameters of the EMA";
extern int M1_Period = 2;
extern int M2_Period = 8;
extern string CCI = "The input parameters of CCI";
extern int CCI_Period = 6;
extern int ValCCI = 0;
extern string RSI = "The input parameters of the RSI";
extern int P_RSI = 8;
extern int RSI_Price = 0;
extern int ValRSI = 50;
extern string MACD = "The input parameters of the MACD";
extern int MACD_Period = 2;
extern int MACD_Period2 = 8;
extern int MACD_Signal = 5;
extern int MACD_Value = 0;
extern string Visual = "Display parameters";
extern string Wingdings = "0 -rectangles, 1 - arrows";
extern int Bar_Wingdings = 0;
extern int Bar_Width = 0;
extern color BarColorUp = Lime;
extern color BarColorDown = Red;
extern color BarColorRange = Yellow;
extern int P1Position = 4;
extern int P2Position = 3;
extern int P3Position = 2;
extern int P4Position = 1;
extern double Gap = 0.6;
extern string SetLabel = "Labels setting";
extern bool ShowLabel = TRUE;
extern string VLabel = "Vertical shift for text labels";
extern double VShift = 0.5;
extern string HLabel = "Horizontal shift for text labels";
extern int HShift = 20;
extern string UP_DN = "direction relative to the price: above/below";
extern color TextColorUp = DeepSkyBlue;
extern color TextColorDown = Red;
extern color TextColorRange = Yellow;
string Gs_unused_272 = "";
string IndiName;
double BufEmaUp[];
double BufEmaDw[];
double G_ibuf_296[];
double BufRsiUp[];
double BufRsiDw[];
double BufCciUp[];
double BufCciDw[];
double BufMacdUp[];
double BufMacdDw[];
double G_ima_324;
double G_ima_332;
double G_ima_340;
double G_icci_356;
double G_irsi_372;
double G_imacd_388;

int init() {
   int ArrowSymbol;
   int i;
   int ArrowSymbol2;
   if (Bar_Wingdings == 0) {
      ArrowSymbol = 110;
      i = 110;
      ArrowSymbol2 = 110;
   }
   if (Bar_Wingdings == 1) {
      ArrowSymbol = 110;
      i = 110;
      ArrowSymbol2 = 110;
   }
   if (Bar_Wingdings != 0 && Bar_Wingdings != 1) {
      Alert("Please enter the correct value for Bar_Wingdings ! (0-3)");
      return -1;
   }
   SetIndexStyle(0, DRAW_ARROW, STYLE_SOLID, Bar_Width, BarColorUp);
   SetIndexArrow(0, ArrowSymbol);
   SetIndexBuffer(0, BufEmaUp);
   SetIndexEmptyValue(0, 0.0);
   SetIndexStyle(1, DRAW_ARROW, STYLE_SOLID, Bar_Width, BarColorDown);
   SetIndexArrow(1, i);
   SetIndexBuffer(1, BufEmaDw);
   SetIndexEmptyValue(1, 0.0);
   SetIndexStyle(2, DRAW_ARROW, STYLE_SOLID, Bar_Width, BarColorUp);
   SetIndexArrow(2, ArrowSymbol);
   SetIndexBuffer(2, BufRsiUp);
   SetIndexEmptyValue(2, 0.0);
   SetIndexStyle(3, DRAW_ARROW, STYLE_SOLID, Bar_Width, BarColorDown);
   SetIndexArrow(3, i);
   SetIndexBuffer(3, BufRsiDw);
   SetIndexEmptyValue(3, 0.0);
   SetIndexStyle(4, DRAW_ARROW, STYLE_SOLID, Bar_Width, BarColorUp);
   SetIndexArrow(4, ArrowSymbol);
   SetIndexBuffer(4, BufCciUp);
   SetIndexEmptyValue(4, 0.0);
   SetIndexStyle(5, DRAW_ARROW, STYLE_SOLID, Bar_Width, BarColorDown);
   SetIndexArrow(5, i);
   SetIndexBuffer(5, BufCciDw);
   SetIndexEmptyValue(5, 0.0);
   SetIndexStyle(6, DRAW_ARROW, STYLE_SOLID, Bar_Width, BarColorUp);
   SetIndexArrow(6, ArrowSymbol);
   SetIndexBuffer(6, BufMacdUp);
   SetIndexEmptyValue(6, 0.0);
   SetIndexStyle(7, DRAW_ARROW, STYLE_SOLID, Bar_Width, BarColorDown);
   SetIndexArrow(7, i);
   SetIndexBuffer(7, BufMacdDw);
   SetIndexStyle(8, DRAW_ARROW, STYLE_SOLID, Bar_Width, BarColorRange);
   SetIndexArrow(8, ArrowSymbol2);
   SetIndexBuffer(8, G_ibuf_296);
   SetIndexEmptyValue(1, 0.0);
   SetIndexEmptyValue(7, 0.0);
   SetIndexLabel(0, "EMA.Up");
   SetIndexLabel(1, "EMA.Dw");
   SetIndexLabel(2, "RSI.Up");
   SetIndexLabel(3, "RSI.Dw");
   SetIndexLabel(4, "CCI.Up");
   SetIndexLabel(5, "CCI.Dw");
   SetIndexLabel(6, "MACD.Up");
   SetIndexLabel(7, "MACD.Dw");
   IndicatorDigits(0);
   IndiName = "Kino";
   IndicatorShortName(IndiName);
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int color_12;
   int color_16;
   int color_20;
   int color_24;
   int ArrowSymbol = IndicatorCounted();
   if (ArrowSymbol < 0) return (-1);
   if (ArrowSymbol > 0) ArrowSymbol--;
   int ArrowSymbol2 = Bars - ArrowSymbol;
   for (int i = ArrowSymbol2; i >= 0; i--) {
      G_ima_324 = iMA(NULL, 0, 1, 0, MODE_SMA, PRICE_MEDIAN, i);
      G_ima_332 = iMA(NULL, 0, M1_Period, 0, MODE_EMA, PRICE_CLOSE, i);
      G_ima_340 = iMA(NULL, 0, M2_Period, 0, MODE_EMA, PRICE_CLOSE, i);
      G_icci_356 = iCCI(NULL, 0, CCI_Period, PRICE_TYPICAL, i);
      G_irsi_372 = iRSI(NULL, 0, P_RSI, RSI_Price, i);
      G_imacd_388 = iMACD(NULL, 0, MACD_Period, MACD_Period2, MACD_Signal, PRICE_CLOSE, MODE_MAIN, i);
      BufEmaUp[i] = EMPTY_VALUE;
      BufEmaDw[i] = EMPTY_VALUE;
      if (G_ima_332 < G_ima_340) {
         BufEmaDw[i] = Gap * P1Position + 1.0;
         color_12 = TextColorDown;
      } else {
         BufEmaUp[i] = Gap * P1Position + 1.0;
         color_12 = TextColorUp;
      }
      BufCciUp[i] = EMPTY_VALUE;
      BufCciDw[i] = EMPTY_VALUE;
      if (G_irsi_372 < ValRSI) {
         BufCciDw[i] = Gap * P3Position + 1.0;
         color_20 = TextColorDown;
      } else {
         BufCciUp[i] = Gap * P3Position + 1.0;
         color_20 = TextColorUp;
      }
      BufRsiUp[i] = EMPTY_VALUE;
      BufRsiDw[i] = EMPTY_VALUE;
      if (G_icci_356 < ValCCI) {
         BufRsiDw[i] = Gap * P2Position + 1.0;
         color_16 = TextColorDown;
      } else {
         BufRsiUp[i] = Gap * P2Position + 1.0;
         color_16 = TextColorUp;
      }
      BufMacdUp[i] = EMPTY_VALUE;
      BufMacdDw[i] = EMPTY_VALUE;
      if (G_imacd_388 < MACD_Value) {
         BufMacdDw[i] = Gap * P4Position + 1.0;
         color_24 = TextColorDown;
      } else {
         BufMacdUp[i] = Gap * P4Position + 1.0;
         color_24 = TextColorUp;
      }
      LabelSet(color_12, color_16, color_20, color_24);
   }
   return (0);
}

int LabelSet(int A_color_0, int A_color_4, int A_color_8, int A_color_12) {
   double price_20;
   string LabelName;
   string text_44;
   color LabelColor;
   double Ld_28 = Time[0] - Time[1];
   if (ShowLabel == TRUE) {
      for (int i = 1; i <= 4; i++) {
         switch (i) {
         case 1:
            text_44 = Time_Frame() + " EMA(" + M1_Period + ")above/below EMA" + M2_Period;
            price_20 = Gap * P1Position + 1.0 + VShift;
            LabelColor = A_color_0;
            break;
         case 2:
            text_44 = Time_Frame() + " CCI(" + CCI_Period + ")above/below" + ValCCI;
            price_20 = Gap * P2Position + 1.0 + VShift;
            LabelColor = A_color_4;
            break;
         case 3:
            text_44 = Time_Frame() + " RSI " + "(" + P_RSI + ")above/below" + ValRSI;
            price_20 = Gap * P3Position + 1.0 + VShift;
            LabelColor = A_color_8;
            break;
         case 4:
            text_44 = Time_Frame() + " MACD( " + MACD_Period + "," + MACD_Period2 + "," + MACD_Signal + ") cross Zero";
            price_20 = Gap * P4Position + 1.0 + VShift;
            LabelColor = A_color_12;
         }
         LabelName = WindowFind(IndiName);
         ObjectDelete(LabelName + i);
         ObjectCreate(LabelName + i, OBJ_TEXT, WindowFind(IndiName), iTime(NULL, 0, 0) + Ld_28 * HShift, price_20);
         ObjectSetText(LabelName + i, text_44, 8, "Arial Bold", LabelColor);
      }
   }
   return (0);
}

string Time_Frame() {
   if (Period() == PERIOD_M1) return ("M1");
   if (Period() == PERIOD_M5) return ("M5");
   if (Period() == PERIOD_M15) return ("M15");
   if (Period() == PERIOD_M30) return ("M30");
   if (Period() == PERIOD_H1) return ("H1");
   if (Period() == PERIOD_H4) return ("H4");
   if (Period() == PERIOD_D1) return ("D1");
   if (Period() == PERIOD_W1) return ("W1");
   if (Period() == PERIOD_MN1) return ("MN");
   return ("");
}
